#!/usr/bin/perl
## ######### PROJECT NAME : ##########
## 
## Lib_TT.pm for wishmin
## 
## ######### PROJECT DESCRIPTION : ###
## 
## This file provides helpers to process templates.
##
## This file became from an personal homemade project
## named bambooweb (ryzome.info). This file is
## primarily release under the BSD license.
## 
## 
## ###################################
## 
## Made by Boutonnet Alexandre
## Email   <aboutonnet@intellique.com>
## 
## Started on  Wed May 13 17:16:33 2009 Boutonnet Alexandre
## Last update Wed May 13 17:22:34 2009 Boutonnet Alexandre
## 
## ###################################
##

package Lib_TT;

use Template;

# Declaration de vars globales.. ca pue je sais..
my $tt;
# Cette hash contient toutes les informations pour generer les templates.
my $vars = {};

# Fonction de creation de l'instance de template toolkit
# Retourne 0 en cas de succes et affiche le
# header d'urgence en cas d'echec..
sub new_tt
{
    my $tt_path = join(':', @_);
    
    $tt = Template->new({
	INCLUDE_PATH => $tt_path,
    });
    
    Lib_CGI::send_critical_header("Error template toolkit") if (!defined($tt));
    return 0;
}

# Fonction de set d'une variable pour tt
sub set
{
    my @tab = @_;
    
    while (@tab)
    {
	my $name = shift(@tab);
	my $var = shift(@tab);
	$vars->{$name} = $var;
    }
}

sub process
{
    my $page = shift;
    
    $tt->process($page, $vars, @_) ||  print $tt->error();	
}

sub debug
{
    use Data::Dumper;

    print "<pre>\n";
    print Dumper $vars;
    print "</pre>\n";
}

1;
